<template>
  <div class="exam-manage">
    <div class="part-box part-box-filter part-box-flex">
      <el-form ref="FilterForm" label-position="left" label-width="85px" inline>
        <template v-if="checkPrivilege('condition', 'condition')">
          <el-form-item label="模板名称：">
            <el-input
              v-model.trim="filter.name"
              placeholder="模板名称"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item label="启用/禁用：" label-width="90px">
            <el-select
              v-model="filter.enable"
              style="width: 120px"
              placeholder="状态"
              clearable
            >
              <el-option
                v-for="(val, key) in ABLE_TYPE"
                :key="key"
                :value="key * 1"
                :label="val"
              ></el-option>
            </el-select>
          </el-form-item>
        </template>
        <el-form-item>
          <el-button
            v-if="checkPrivilege('button', 'select')"
            type="primary"
            @click="toPage(1)"
            >查询</el-button
          >
        </el-form-item>
      </el-form>
      <div class="part-box-action">
        <el-button
          v-if="checkPrivilege('button', 'add')"
          type="primary"
          icon="el-icon-circle-plus-outline"
          @click="toAdd"
          >新增</el-button
        >
      </div>
    </div>
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="dataList">
        <el-table-column
          type="index"
          label="序号"
          width="70"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column prop="name" label="模板名称"></el-table-column>
        <el-table-column prop="createTime" label="创建时间" width="170">
          <span slot-scope="scope">{{
            scope.row.createTime | timestampFilter
          }}</span>
        </el-table-column>
        <el-table-column prop="enable" label="启用/禁用" width="100">
          <template slot-scope="scope">
            {{ scope.row.enable | enableFilter }}
          </template>
        </el-table-column>
        <el-table-column
          class-name="action-column"
          label="操作"
          width="180px"
          fixed="right"
        >
          <template slot-scope="scope">
            <el-button
              v-if="checkPrivilege('link', 'preview')"
              class="btn-primary"
              type="text"
              @click="toView(scope.row)"
              >查看</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'edit')"
              class="btn-primary"
              type="text"
              @click="toEdit(scope.row)"
              >编辑</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'Enable')"
              :class="scope.row.enable ? 'btn-danger' : 'btn-primary'"
              type="text"
              @click="toEnable(scope.row)"
              >{{ scope.row.enable ? "禁用" : "启用" }}</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'Delete')"
              class="btn-danger"
              type="text"
              @click="toDelete(scope.row)"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          background
          layout="total, sizes, prev, pager, next, jumper"
          :pager-count="5"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
          @size-change="pageSizeChange"
        >
        </el-pagination>
      </div>
    </div>

    <!-- ModifyCourseTargetTemplate -->
    <modify-course-target-template
      ref="ModifyCourseTargetTemplate"
      v-if="checkPrivilege('link', 'edit')"
      :instance="curRow"
      @modified="getList"
    ></modify-course-target-template>
  </div>
</template>

<script>
import {
  courseTargetTemplateListPage,
  deleteCourseTargetTemplate,
  ableCourseTargetTemplate,
} from "../api";
import { ABLE_TYPE } from "@/constants/enumerate";
import ModifyCourseTargetTemplate from "../components/ModifyCourseTargetTemplate.vue";

export default {
  name: "course-target-template-manage",
  components: { ModifyCourseTargetTemplate },
  data() {
    return {
      filter: {
        name: "",
        enable: "",
      },
      ABLE_TYPE,
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      dataList: [],
      curRow: {},
    };
  },
  mounted() {
    // this.getList();
  },
  methods: {
    async getList() {
      if (!this.checkPrivilege("list", "list")) return;

      const datas = {
        ...this.filter,
        pageNumber: this.current,
        pageSize: this.size,
      };
      if (datas.enable !== null && datas.enable !== "")
        datas.enable = !!datas.enable;

      const data = await courseTargetTemplateListPage(datas);
      this.dataList = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toAdd() {
      this.curRow = {};
      this.$refs.ModifyCourseTargetTemplate.open();
    },
    toEdit(row) {
      this.curRow = row;
      this.$refs.ModifyCourseTargetTemplate.open();
    },
    toView(row) {
      this.curRow = row;
      // TODO:
    },
    toDelete(row) {
      this.$confirm(`确定要删除模板【${row.name}】吗?`, "提示", {
        type: "warning",
      })
        .then(async () => {
          await deleteCourseTargetTemplate(row.id);
          this.$message.success("删除成功！");
          this.deletePageLastItem();
        })
        .catch(() => {});
    },
    toEnable(row) {
      const action = row.enable ? "禁用" : "启用";
      this.$confirm(`确定要${action}模板【${row.name}】吗?`, "提示", {
        type: "warning",
      })
        .then(async () => {
          const enable = !row.enable;
          await ableCourseTargetTemplate({
            id: row.id,
            enable,
          });
          row.enable = enable;
          this.$message.success("操作成功！");
        })
        .catch(() => {});
    },
  },
};
</script>
